#ifndef CDBConnPool_h__
#define CDBConnPool_h__


/**
* @brief
ݿӳ

* @version
V 1.0.0

* @author
濡

* @date
ʱ:  2018-04-17\n

* @note
2018-04-17  ࡣ\n

* @warning

* @bug

*/

#pragma once

#include <boost/atomic.hpp>
#include <boost/thread/thread.hpp>
#include <boost/serialization/singleton.hpp>

#include <list>
#include <string>
#include <mutex>

#include "CDBCommon.h"
#include "CDBConnect.h"

namespace YADB
{
	class CDBConnPool
	{
	private:
		std::list<CDBConnect*> __BusyConnList;//ʹõݿб
		std::list<CDBConnect*> __IdleConnList;//ûʹõݿб
		_DB_POOL_SETTING_ __Setting;//ݿӳ
		std::mutex __mtx;//
		boost::atomic<bool> __Running{ true };//߳Ƿеıʶ		
		boost::atomic<bool> __IsExited{ false };//߳Ƿ˳ıʶ
		CDBConnect* __pAsyncDBConn;//첽ִ߳õݿ
	private:
		/**

		* @brief
		һӺ
		* @param  [out] std::string& Error  Ϣ\n
		* @param  [in] bool IsTemp  Ƿʱ\n

		* @return ش
		* @return  >0   ɹ\n
		* @return  ==0  ʧ\n

		* @note

		* @warning
		* @bug

		*/
		CDBConnect* __CreateIdleConn( std::string& Error, bool IsTemp = false );
		/**
		* @brief
		첽ִ߳Ӻ

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug
		*/
		void __CreateAsyncThrdConn();
		/**
		* @brief
		??????첽ִ߳Ӻ

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void __DestroyAsyncThrdConn();
		/**
		* @brief
		첽ִ̺߳

		* @param  \n

		* @return 

		* @note

		* @warning

		* @bug

		*/
		void __StartAsyncThrd();
		/**
		* @brief
		ֹͣ첽ִ̺߳

		* @param  \n

		* @return 

		* @note

		* @warning

		* @bug

		*/
		void __StopAsyncThrd();
	protected:
		/**
		* @brief
		첽ִ̺߳

		* @param  [in] CDBConnPool* pOwner  ߳\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void _AsyncThreadFunc( CDBConnPool* pOwner );//̺߳
	public:
		CDBConnPool();
		~CDBConnPool();
		/**
		* @brief
		ݿӳغ

		* @param  [in] const _DB_POOL_SETTING_& Setting  ݿӳ\n
		* @param  [out] std::string& Error  Ϣ\n

		* @return شݿӳǷɹ
		* @return  true   ɹ
		* @return  false  ʧ

		* @note

		* @warning

		* @bug

		*/
		bool Create( const _DB_POOL_SETTING_& Setting, std::string& Error );
		/**
		* @brief
		ر̳߳غ

		* @param  \n

		* @return  \n

		* @note

		* @warning

		* @bug

		*/
		void Close();
		/**
		* @brief
		ӳлһݿӺ

		* @param  [out] std::string& Error  Ϣ\n

		* @return ػһݿǷɹ
		* @return  0 ʧ\n
		* @return  !=0 õݿ\n

		* @note

		* @warning

		* @bug

		*/
		CDBConnect* GetDBConnect( std::string& Error );
		/**
		* @brief
		黹һݿӵӳк

		* @param  [in] CDBConnect* pConn  ݿ\n

		* @return  \n

		* @note

		* @warning

		* @bug

		*/
		void GiveBack( CDBConnect* pConn );
		/**
		* @brief
		SQL첽ִжк

		* @param  [in] const std::string& strSQL  ҪִеSQL\n

		* @return  첽ִжǷɹ\n
		* @return  trueɹ\n
		* @return  falseʧ\n

		* @note

		* @warning

		* @bug

		*/
		bool PushAsync( const std::string& strSQL );
		/**
		* @brief
		ִSQL䷵ؽ

		* @param [in] const char *szSql  SQL\n
		* @param [out] CDBResultSet& DBRes  \n
		* @param [out] std::string& Error  Ϣ\n

		* @return زѯǷɹ
		* @return  true  ɹ\n
		* @return  false  ʧ\n

		* @note

		* @warning

		* @bug

		*/
		bool Query( const char *szSql, CDBResultSet& DBRes, std::string& Error );
		/**
		* @brief
		ִSQL䷵ԭ

		* @param [in] const char *szSql  SQL\n
		* @param [out] std::string& Error  Ϣ\n

		* @return زѯĽ

		* @note

		* @warning

		* @bug

		*/
		MYSQL_RES* Query( const char *szSql, std::string& Error );
		/**
		* @brief
		ִSQL亯

		* @param [in] const char *szSql  SQL\n
		* @param [out] std::string& Error  Ϣ\n

		* @return Ӱ쵽ļ¼
		* @return  -1  ʧ\n
		* @return  >=0  ɹ\n

		* @note

		* @warning

		* @bug

		*/
		my_ulonglong ExecuteSql( const char *szSql, std::string& Error );
		/**
		* @brief
		ִSQL䲢IDĺ

		* @param [in] const char *szSql  SQL\n
		* @param [out] std::string& Error  Ϣ\n

		* @return ػõID
		* @return  <=0  ʧ\n
		* @return  >0   ɹ\n

		* @note

		* @warning

		* @bug

		*/
		my_ulonglong ExecuteSqlID( const char *szSql, std::string& Error );
	};
}

//ض
typedef boost::serialization::singleton<YADB::CDBConnPool> singleton_CDBConnPool;
#define sDBConnPool singleton_CDBConnPool::get_mutable_instance()

#endif // CDBConnPool_h__
